import { descending, max } from 'd3';

export const getTop10BarData = (data, xValue) => {
  //  console.log("sumData data: ", data);
  //	console.log("sumData xValue: ", xValue);
  //  console.log(data[1]);

  const stateCounts = {};
  const stateTotals = {};
  const stateSummary = {};

  const stateTotalWeekly = data
    .filter(d => xValue(d) !== 'X')
    .filter(d => d['YEAR'] === '2018')
    .map(d => {
      d.value = xValue(d);
      if (d.value) {
        if (!stateTotals[d['REGION']]) {
          stateTotals[d['REGION']] = 0;
          stateCounts[d['REGION']] = 0;
        }
        stateTotals[d['REGION']] += d.value;
        stateCounts[d['REGION']]++;
      }
      return d;
    });
  // console.log(stateTotalWeekly);
  // console.log(stateTotals);
  // console.log(stateCounts);

  const topStates = {};

//   Object.entries(stateTotals)
//     .map(([state, total]) => ({ state, total }))
//     .sort((a, b) => descending(a.total, b.total))
//     .slice(0, 10)
//     .forEach(d => (topStates[d.state] = true));

  const topData = data.filter(d => topStates[d['State']]);
//  console.log(topData);

  const array1 = Object.values(stateTotals);
  const array2 = Object.values(stateCounts);
  const array3 = Object.keys(stateTotals).map((state, i) => {
    return { state: state,
       total: array1[i],
       count: array2[i],
       avg: array1[i]/array2[i] };
  });

//  console.log(array3);

//    .map(([state, total]) => ({ state, total }))
  const array4 = array3
    .sort((a, b) => descending(a.avg, b.avg))
    .slice(0, 10);
  
  array4.forEach(d => (topStates[d.state] = true));

  //top 10 States filled!
  // console.log(topStates);
  // console.log(array4);

  const topStateSum = {};

  const topStateSum1 = topData
    .filter(d => xValue(d) !== 'X')
    //    .filter(d => d['YEAR'] === '2018')
    //    .filter(d => d['YEAR'] === '2019')
    .map(d => {
      d.value = xValue(d);
      if (!topStateSum[d['REGION']]) {
        topStateSum[d['REGION']] = 0;
      }
      topStateSum[d['REGION']] += d.value;
      return d;
    });

//  console.log(topStateSum1);

  // for (let [key, value] of Object.entries(topStateSum)) {
  //   console.log(`${key}: ${value}`);
  // }

  //Array to object
  const arrayToObject = (array, keyField) =>
    array.reduce((obj, item) => {
      obj[item[keyField]] = item;
      return obj;
    }, {});

  //Not working!
  //const peopleObject = arrayToObject(topStateSum, "id");
  //console.log(peopleObject);

  //reduce data
  //const nationalData = data.filter(d => d['Week']);

  const top10BarData = Object.entries(topStateSum)
    .map(([state, total]) => ({ State: state, Tvalue: total }))
    .sort((a, b) => descending(a.Tvalue, b.Tvalue));

  const top10BarData1 = array4
    .map((d) => ({ State: d.state, Tvalue: d.avg }))
  return top10BarData1;
};
